r0_only_middle := proc(NextGen,gparam,gtotal,x0,p0,imap)

local i, j, n, kdim, xdim, gs, gx, sname, si, k,m,s,S,SPattern, var, SIndex, STerms, splits,terms, Terms,ThisTerm,realterms,ETerms,VTerms,FTerms,nflag,pflag,nparens,temp,num, calF,calV,F,V,E, eqstring, FEqs, VEqs, Vars, Vals, NG, Evals, evals, ind, r0, R0, dR0dx, dR0dp, r1vals, r1spec, r1, Ftest, Vtest, r2F, r2V, NoInf, exit, Jvars, Jvals, Jeqs, Cmat, Cval, r3vals, r3spec, r3, drdp, xeq, dr0dp, singV, r4,  Mvars, Mvals, Meqs, Mmat, Mval, r5, y, XIndex;

with(CodeGeneration):
with(StringTools):
with(ArrayTools):

xdim:=gparam[1];
kdim:=gparam[2];


# Convert the strings into equations for manipulation
gs:=StringTools[Split](gtotal,";");

for i from 1 to xdim do:
  gx[i]:=parse(gs[i]):
end do:

# In case the population is scaled by the total population, hide disease-free states that are just scaling factors
# This is necessary as the occurrence of a disease-free state is the determining factor if that term belongs in F or V
# Define N = sum of all states
var := 0:
for i from 1 to xdim do:
   var := var + x[i]:
end do:

# Substitute N into all equations and expand the equations in order to isolate terms
for i from 1 to xdim do:
   gx[i] := expand(subs(var = N, gx[i])):
end do:

# Convert back into strings for string manipulation
for i from 1 to xdim do:
  gs[i] := convert(gx[i], string):
end do:

# Identify all the non-infected classes as indicators of terms that belong in F
# Note:  This loop is best implemented with the MAPLE "in" command, however if used, MATLAB crashes
NoInf := Array([]): 
for i from 1 to xdim do:
   exit := 0: 
   for j from 1 to ArrayTools[Size](NextGen, 2) do:
      if NextGen[j] = i or NextGen = i then 
         exit := 1:
      else  
      end if;
   end do:
   if exit = 1 then
   else 
      NoInf := ArrayTools[Concatenate](2, NoInf, i):
   end if;
end do:

singV := 0;    # this variable will check if V has any obvious singularities

# Construct the Matrix mathcal(F) and mathcal(V)
for E from 1 to ArrayTools[Size](NextGen,2) do:
   if singV = 0 then     # another test condition -- if there is a singular term, stop trying!

   calF[E]:=0:  calV[E]:=0:
   if ArrayTools[Size](NextGen, 2) = 1 then 
      eqstring := gs[NextGen]:
   else 
      eqstring := gs[NextGen[E]]:
   end if; 

   if parse(eqstring) = 0 then          # the equation may be 0 -- ex: Pine12b g[7]
      # If the equation is 0, this will make V singular: do not try to compute V^{-1}
      singV:=NextGen[E]:
   else

      # Split up equation by + and - for the partial terms (eventually to determine if it belongs in F or V)
      splits := sort([StringTools[SearchAll]("+", eqstring), StringTools[SearchAll]("-", eqstring)]):
      terms := Array([substring(eqstring, 1 .. splits[1]-1)]):
      for i from 2 to  ArrayTools[Size]([splits],2) do:
         terms := ArrayTools[Concatenate](2, terms, substring(eqstring, splits[i-1] .. splits[i]-1)):
      end do:
      terms := ArrayTools[Concatenate](2, terms, substring(eqstring, splits[ArrayTools[Size]([splits],2)] .. length(eqstring))):


      #If the first term starts with - then term[1] will be " " and should be removed
      if terms[1]="" then 
         for i from 1 to ArrayTools[Size](terms,2)-1 do:
            terms[i] := terms[i+1]:
         end do:
         terms := terms[1 .. ArrayTools[Size](terms,2)-1]:
      end if;


      # Now we need to look through the indicies of partial terms and see if there are any ('s to construct complete Terms
      Terms := Array([]):
      for i from 1 to ArrayTools[Size](terms,2) do:
         pflag := 0: nflag := 0:
         for j from 1 to  length(terms[i]) do:     # this loops over each element in term i to see if ( appears
            if "(" = terms[i][j] then
               pflag := pflag+1:                     # flags the number of ( that appear in term i
            end if;
            if ")" = terms[i][j] then
               nflag := nflag+1:                   # flags the number of ) that appear in term i
            end if;
         end do: 
         nparens := pflag-nflag:                    # number of parens sets missing a )
      
         if nparens>0 then                         # then term i should include at least term i+1
            for k from i+1 to ArrayTools[Size](terms,2) while nparens>0 do:
               for m from 1 to length(terms[k]) do:      # loops over remaining terms to balance out nparens
                  if "("=terms[k][m] then
                     nparens := nparens+1:
                  end if;
                  if ")" = terms[k][m] then 
                     nparens := nparens-1:
                  end if;
               end do:
            end do:
            ThisTerm := terms[i]:
            for n from i+1 to k-1 do:             # current term will include up to the balancing term
               ThisTerm := cat(ThisTerm, terms[n]):
            end do:
            Terms := ArrayTools[Concatenate](1, Terms, ThisTerm):   #only problem now is + and - at beginnings
            i := k-1:                             # update i so that it doesn't double over the balancing terms
         else                   #then the term doesn't have any ()'s
            ThisTerm := terms[i]:
            Terms := ArrayTools[Concatenate](1, Terms, ThisTerm):
         end if;
      end do:


      #Check if there is only one Term!
      if length(Terms[1]) = 1 then
         realterms := convert(Terms[1], string):
         for i from 2 to length(eqstring) do:
            temp := convert(Terms[i], string):
            realterms := cat(realterms, temp):
         end do:
         Terms[1] := realterms:
      end if;
   

      #Put the whole Terms back into equation form-- ETerms
      ETerms := Array([parse(Terms[1])]):
      for i from 2 to ArrayTools[Size](Terms,1) do:
         ETerms := ArrayTools[Concatenate](2, ETerms, parse(Terms[i])):
      end do:
   
 
      # See if the Terms belong in F or V -- search through NoInf
      VTerms := Matrix(ArrayTools[Size](ETerms,2), 1):
      FTerms := Matrix(ArrayTools[Size](ETerms,2), 1):

      if ArrayTools[Size](NoInf, 2) = 1 then
         num := convert(NoInf, string):
         SPattern[1] := cat("x[", num, "]"):
      else 
         for s from 1 to ArrayTools[Size](NoInf, 2) do:
            num := convert(NoInf[s], string):
            SPattern[s] := cat("x[", num, "]"):
         end do: 
      end if;

      for i from 1 to ArrayTools[Size](ETerms, 2) do:
         S := 0; 
         for s from 1 to ArrayTools[Size](NoInf, 2) do:
            SIndex := StringTools[SearchAll](SPattern[s], Terms[i]);
               if SIndex = NULL then  # don't add to S  
                  else S := 1 
               end if;
         end do:

         # another criterion for belonging in calF is if the entire term is parameter(s)
         # search through to see if there is any "x" in this term
         XIndex := StringTools[SearchAll]("x", Terms[i]); 
         if XIndex = NULL then S := 1  
         end if;

         if S = 0 then  # this term belongs in V and should be negated if ODE
            if imap = 0 then
               VTerms[i] := -(ETerms[i]);
            else 
               VTerms[i] := ETerms[i];
            end if;
         else 
            FTerms[i] := ETerms[i]:
         end if;
      end do:

      # Now that F and V are identified, unhide N
      FTerms := eval(FTerms, N = var): 
      VTerms := eval(VTerms, N = var):


      # Combine FTerms and VTerms into mathcal(F) and mathcal(V)
      calF[E] := 0: calV[E] := 0:
      for i from 1 to ArrayTools[Size](Terms,1) do:
         calF[E] := calF[E]+FTerms[i][1]:
         calV[E] := calV[E]+VTerms[i][1]:
      end do:

   end if;
   end if;
end do:



# Compute the Jacobians F and V evaluated at disease-free equilibrium
FEqs := NULL: VEqs := NULL: Vars := "": Vals := "": 
for i from 1 to ArrayTools[Size](NextGen,2) do:
   FEqs := FEqs, calF[i]: 
   VEqs := VEqs, calV[i]: 
   if ArrayTools[Size](NextGen,2) = 1 then
      Vars := cat(Vars, "x[", NextGen, "], "):
   else
      Vars := cat(Vars, "x[", NextGen[i], "], "):
   end if;
   Vals := cat(Vals, "0, "):
end do: 

Vars := substring(Vars, 1 .. length(Vars)-2): 
Vals := substring(Vals, 1 .. length(Vals)-2): 
F := VectorCalculus[Jacobian]([FEqs], [parse(Vars)] = [parse(Vals)]): 
V := VectorCalculus[Jacobian]([VEqs], [parse(Vars)] = [parse(Vals)]):

# To avoid big problems, force infection classes to be 0 for the user
xeq:=x0:
if ArrayTools[Size](NextGen,2) = 1 then
   xeq[NextGen]:=0:
else
   for i from 1 to ArrayTools[Size](NextGen,2) do:
      xeq[NextGen[i]]:=0:
   end do:
end if;

F:=evalf(eval(F,{p=p0,x=xeq})):
V:=evalf(eval(V,{p=p0,x=xeq})):

# Test for singular V beyond "zero" classes (ex: incorrect placement of terms in F and V)
if LinearAlgebra[Determinant](V) = 0 then
   singV := 100;     # singV identifies the equation that is identically zero. If singV = 100, a different warning will display.
end if;

if singV = 0 then
   # Compute R0 numerically
   with(LinearAlgebra): 
   if imap = 1 then 
      NG := LinearAlgebra[MatrixMatrixMultiply](F, LinearAlgebra[MatrixInverse](LinearAlgebra[IdentityMatrix](ArrayTools[Size](NextGen, 2))-V)):
   else 
      NG := LinearAlgebra[MatrixMatrixMultiply](F, LinearAlgebra[MatrixInverse](V));
   end if;
   evals := LinearAlgebra[Eigenvalues](NG):

   ind := 0: r0 := 0: 
   for i from 1 to ArrayTools[Size](evals, 1) do:
      if abs(evals(i)) > r0 then 
         r0 := abs(evals(i)): 
         ind := i:
      end if;
   end do:
   if ind = 0 then    # this will occur if all eigenvalues are negligible
      ind:=1;          
   end if;
   R0 := abs(evals(ind)):
   r4 := 0:     # no warning for singular matrix V
else
   R0 := 0:     # so that it outputs something
end if;

Matlab(R0,resultname = "R0", output= "r0_matrix.m");

# Include sensitivity equations for iteration in Matlab
for i from 1 to xdim do:
   dR0dx[i] := 0:
end do:

for j from 1 to kdim do:
   dR0dp[j] := 0:
end do:

for i from 1 to xdim do:
   si := convert(i,string);
   sname := cat("dR0dx",si);
   Matlab(dR0dx[i], resultname=sname, output="r0_matrix.m");
end do:

for i from 1 to kdim do:
    si := convert(i,string);
    sname := cat("dR0dp",si);
    Matlab(dR0dp[i], resultname=sname, output="r0_matrix.m");
end do:


############################################################################
# Does the theorem hold?  Test the following to see if this is a valid R0: #
############################################################################

# Requirement 1:  the spectral radius of V must be less than 1 (MAPS only)

Ftest := eval(F, {p = p0, x = x0}):
Vtest := eval(V, {p = p0, x = x0}):
r1vals := LinearAlgebra[Eigenvalues](Vtest): 
r1spec := max(abs(r1vals)):

r1 := 0: 
if r1spec > 1 then 
   r1 := 1:
end if;

if imap = 0 then
   r1:=0:        # It doesn't matter if p(T) < 1 for ODE models
end if;

Matlab(r1,resultname = "warning1", output= "r0_matrix.m");

# Requirement 2:  F >= 0 and V>=0 (MAPS only.  V may be negative for ODE models)


r2F:=0:  r2V:=0:

for i from 1 to ArrayTools[Size](Ftest, 1) do:
   for j from 1 to ArrayTools[Size](Ftest, 2) do:
      if Ftest[i][j] < 0 then 
         r2F := 1:
      end if;
      if Vtest[i][j] < 0 then 
         r2V := 1:
      end if;
   end do:
end do:

if imap = 0 then
   r2V:=0:        # It doesn't matter if V is negative for ODE models
end if;

Matlab(r2F,resultname = "warning2_F", output= "r0_matrix.m");
Matlab(r2V,resultname = "warning2_V", output= "r0_matrix.m");

# Requirement 3: The DFE must be stable in the absence of disease.  
# MAPS: For the non-"NextGen" states, the spectral radius of the Jacobian must be less than 1.  
# ODES: (A5) The entire Jacobian must have all negative real part eigenvalues if NextGen states = 0.

for i from 1 to xdim do:
   gx[i] := eval(gx[i], N = var):
end do:

if imap = 1 then
   Jvars := "": Jvals := "":
   
   if ArrayTools[Size](NoInf,2) = 1 then
      Jvars := cat("x[", NoInf, "]"):
      Jvals := convert(x0[NoInf], string):
      Jeqs := gx[NoInf]:
   else
      for i from 1 to ArrayTools[Size](NoInf,2) do:
         Jvars := cat(Jvars, "x[", NoInf[i], "], "):
         Jvals := cat(Jvals, convert(x0[NoInf[i]], string), ", "):
      end do:
      Jvars := substring(Jvars, 1 .. length(Jvars)-2):
      Jvals := substring(Jvals, 1 .. length(Jvals)-2):

      Jeqs := NULL:
      for i from 1 to ArrayTools[Size](NoInf, 2) do:
         Jeqs := Jeqs, gx[NoInf[i]]:
      end do:
   end if;

   Cmat := VectorCalculus[Jacobian]([Jeqs], [parse(Jvars)] = [parse(Jvals)]):
   Cval := evalf(eval(Cmat,{p=p0,x=xeq})):               # we don't need algebraic eigenvalues, just numerical!
   r3vals := LinearAlgebra[Eigenvalues](Cval):
   r3spec := max(abs(r3vals)):

   r3 := 0: 
   if r3spec > 1 then 
      r3 := 1:
   end if;
else 
   Mvars := "": Mvals := "":
   for i from 1 to xdim do:
      Mvars := cat(Mvars, "x[", i, "], "):
      Mvals := cat(Mvals, convert(x0[i], string), ", "):
   end do:
   Mvars := substring(Mvars, 1 .. length(Mvars)-2):
   Mvals := substring(Mvals, 1 .. length(Mvals)-2):

   for i from 1 to ArrayTools[Size](NextGen,2) do:   
      if ArrayTools[Size](NextGen,2) = 1 then 
         gx[NextGen]:=gx[NextGen]-FEqs:                  # Set cal{F} = 0
      else
         gx[NextGen[i]]:=gx[NextGen[i]]-FEqs[i]:         # Set cal{F} = 0
      end if;
   end do:

   Meqs := NULL:
   for i from 1 to xdim do:
      Meqs := Meqs, gx[i]:
   end do:

   Mmat := VectorCalculus[Jacobian]([Meqs], [parse(Mvars)] = [parse(Mvals)]):
   Mval := evalf(eval(Mmat,{p=p0,x=xeq})):               # we don't need algebraic eigenvalues, just numerical!
   r3vals := LinearAlgebra[Eigenvalues](Mval):
   r3vals := Re(r3vals):

   r3:=0:
   for i from 1 to ArrayTools[Size](r3vals,1) do:
      if r3vals(i)>0 then
         r3:=1:
      end if;
   end do:
end if;

Matlab(r3,resultname = "warning3", output= "r0_matrix.m");

Matlab(singV,resultname = "warning4", output= "r0_matrix.m");


# Requirement 4: (A4) for ODEs: if x is disease-free, it remains disease-free: that is, calF = 0

r5 := 0:
if imap = 0 then
   # use a vector with zero disease-states and 1 non-disease states
   y := Vector(xdim):
   for i from 1 to ArrayTools[Size](NoInf,2) do:
      if ArrayTools[Size](NoInf,2) = 1 then
         y[NoInf] :=1:
      else
         y[NoInf[i]] := 1:
      end if;
   end do:
 
   for i from 1 to ArrayTools[Size](NextGen, 2) do:
      if ArrayTools[Size](NextGen,2) = 1 then
         if eval(FEqs,{p=p0,x=y})>0 then
            r5:= NextGen:
         end if;
      else
         if eval(FEqs[i], {p = p0, x = y}) > 0 then
            r5 := NextGen[i]:
         end if;
      end if;
   end do:
end if;

Matlab(r5,resultname = "warning5", output= "r0_matrix.m");

end proc;

