function [dgdp] = dgvec_dparam(x,p) 

xdim=length(x); 
kdim=length(p); 
dgdp = zeros(xdim,kdim+xdim); 

dg1dp1 = (x(2) + 0.5e0 * x(4)) ^ 2 / (x(2) + x(4) + x(6));
dg1dp2 = -p(3) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * x(1);
dg1dp3 = exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2)) * x(1);
dg1dp4 = 0;
dg1dp5 = p(3) * (-x(1) - x(2) - x(3) - x(4) - x(5) - x(6)) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2)) * x(1);
dg1dp6 = 0;
dg1dp7 = 0;
dg2dp1 = 0;
dg2dp2 = p(3) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * x(1);
dg2dp3 = exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2) * x(1);
dg2dp4 = x(2);
dg2dp5 = p(3) * (-x(1) - x(2) - x(3) - x(4) - x(5) - x(6)) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2) * x(1);
dg2dp6 = 0;
dg2dp7 = 0;
dg3dp1 = 0.2e1 * (x(2) + 0.5e0 * x(4)) / (x(2) + x(4) + x(6)) * (0.5e0 * x(4) + x(6));
dg3dp2 = -(1 - p(6) * p(7)) * p(3) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * x(3);
dg3dp3 = (1 - p(6) * p(7)) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(3);
dg3dp4 = 0;
dg3dp5 = (1 - p(6) * p(7)) * p(3) * (-x(1) - x(2) - x(3) - x(4) - x(5) - x(6)) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(3);
dg3dp6 = -p(7) * p(3) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2)) * x(3);
dg3dp7 = -p(6) * p(3) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2)) * x(3);
dg4dp1 = 0;
dg4dp2 = (1 - p(6) * p(7)) * p(3) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * x(3);
dg4dp3 = (1 - p(6) * p(7)) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(3);
dg4dp4 = (1 - p(6) * p(7)) * x(4);
dg4dp5 = (1 - p(6) * p(7)) * p(3) * (-x(1) - x(2) - x(3) - x(4) - x(5) - x(6)) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(3);
dg4dp6 = -p(7) * (p(3) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2) * x(3) + p(4) * x(4));
dg4dp7 = -p(6) * (p(3) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2) * x(3) + p(4) * x(4));
dg5dp1 = (0.5e0 * x(4) + x(6)) ^ 2 / (x(2) + x(4) + x(6));
dg5dp2 = -(1 - p(7)) * p(3) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * x(5);
dg5dp3 = (1 - p(7)) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(5);
dg5dp4 = 0;
dg5dp5 = (1 - p(7)) * p(3) * (-x(1) - x(2) - x(3) - x(4) - x(5) - x(6)) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(5);
dg5dp6 = 0;
dg5dp7 = -p(3) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2)) * x(5);
dg6dp1 = 0;
dg6dp2 = (1 - p(7)) * p(3) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * x(5);
dg6dp3 = (1 - p(7)) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(5);
dg6dp4 = (1 - p(7)) * x(6);
dg6dp5 = (1 - p(7)) * p(3) * (-x(1) - x(2) - x(3) - x(4) - x(5) - x(6)) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(5);
dg6dp6 = 0;
dg6dp7 = -p(3) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2) * x(5) - p(4) * x(6);

dgdp(1,1) = dg1dp1; 
dgdp(1,2) = dg1dp2; 
dgdp(1,3) = dg1dp3; 
dgdp(1,4) = dg1dp4; 
dgdp(1,5) = dg1dp5; 
dgdp(1,6) = dg1dp6; 
dgdp(1,7) = dg1dp7; 
dgdp(2,1) = dg2dp1; 
dgdp(2,2) = dg2dp2; 
dgdp(2,3) = dg2dp3; 
dgdp(2,4) = dg2dp4; 
dgdp(2,5) = dg2dp5; 
dgdp(2,6) = dg2dp6; 
dgdp(2,7) = dg2dp7; 
dgdp(3,1) = dg3dp1; 
dgdp(3,2) = dg3dp2; 
dgdp(3,3) = dg3dp3; 
dgdp(3,4) = dg3dp4; 
dgdp(3,5) = dg3dp5; 
dgdp(3,6) = dg3dp6; 
dgdp(3,7) = dg3dp7; 
dgdp(4,1) = dg4dp1; 
dgdp(4,2) = dg4dp2; 
dgdp(4,3) = dg4dp3; 
dgdp(4,4) = dg4dp4; 
dgdp(4,5) = dg4dp5; 
dgdp(4,6) = dg4dp6; 
dgdp(4,7) = dg4dp7; 
dgdp(5,1) = dg5dp1; 
dgdp(5,2) = dg5dp2; 
dgdp(5,3) = dg5dp3; 
dgdp(5,4) = dg5dp4; 
dgdp(5,5) = dg5dp5; 
dgdp(5,6) = dg5dp6; 
dgdp(5,7) = dg5dp7; 
dgdp(6,1) = dg6dp1; 
dgdp(6,2) = dg6dp2; 
dgdp(6,3) = dg6dp3; 
dgdp(6,4) = dg6dp4; 
dgdp(6,5) = dg6dp5; 
dgdp(6,6) = dg6dp6; 
dgdp(6,7) = dg6dp7; 

end
