function [dgdx] = dgvec_dxvec(x,p) 

xdim=length(x); 
dgdx = zeros(xdim,xdim); 

dg1dx1 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2)) * x(1) + p(3) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2));
dg1dx2 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2)) * x(1) + 0.2e1 * p(1) * (x(2) + 0.5e0 * x(4)) / (x(2) + x(4) + x(6)) - p(1) * (x(2) + 0.5e0 * x(4)) ^ 2 / (x(2) + x(4) + x(6)) ^ 2;
dg1dx3 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2)) * x(1);
dg1dx4 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2)) * x(1) + 0.10e1 * p(1) * (x(2) + 0.5e0 * x(4)) / (x(2) + x(4) + x(6)) - p(1) * (x(2) + 0.5e0 * x(4)) ^ 2 / (x(2) + x(4) + x(6)) ^ 2;
dg1dx5 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2)) * x(1);
dg1dx6 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * (0.1e1 - p(2)) * x(1) - p(1) * (x(2) + 0.5e0 * x(4)) ^ 2 / (x(2) + x(4) + x(6)) ^ 2;
dg2dx1 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2) * x(1) + p(3) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2);
dg2dx2 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2) * x(1) + p(4);
dg2dx3 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2) * x(1);
dg2dx4 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2) * x(1);
dg2dx5 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2) * x(1);
dg2dx6 = -p(3) * p(5) * exp(-p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6))) * p(2) * x(1);
dg3dx1 = -(1 - p(6) * p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(3);
dg3dx2 = -(1 - p(6) * p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(3) + 0.2e1 * p(1) / (x(2) + x(4) + x(6)) * (0.5e0 * x(4) + x(6)) - 0.2e1 * p(1) * (x(2) + 0.5e0 * x(4)) / ((x(2) + x(4) + x(6)) ^ 2) * (0.5e0 * x(4) + x(6));
dg3dx3 = -(1 - p(6) * p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(3) + (1 - p(6) * p(7)) * p(3) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2));
dg3dx4 = -(1 - p(6) * p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(3) + 0.10e1 * p(1) / (x(2) + x(4) + x(6)) * (0.5e0 * x(4) + x(6)) - 0.2e1 * p(1) * (x(2) + 0.5e0 * x(4)) / ((x(2) + x(4) + x(6)) ^ 2) * (0.5e0 * x(4) + x(6)) + 0.10e1 * p(1) * (x(2) + 0.5e0 * x(4)) / (x(2) + x(4) + x(6));
dg3dx5 = -(1 - p(6) * p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(3);
dg3dx6 = -(1 - p(6) * p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(3) - 0.2e1 * p(1) * (x(2) + 0.5e0 * x(4)) / ((x(2) + x(4) + x(6)) ^ 2) * (0.5e0 * x(4) + x(6)) + 0.2e1 * p(1) * (x(2) + 0.5e0 * x(4)) / (x(2) + x(4) + x(6));
dg4dx1 = -(1 - p(6) * p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(3);
dg4dx2 = -(1 - p(6) * p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(3);
dg4dx3 = (1 - p(6) * p(7)) * (-p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(3) + p(3) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2));
dg4dx4 = (1 - p(6) * p(7)) * (-p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(3) + p(4));
dg4dx5 = -(1 - p(6) * p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(3);
dg4dx6 = -(1 - p(6) * p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(3);
dg5dx1 = -(1 - p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(5);
dg5dx2 = -(1 - p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(5) - p(1) * (0.5e0 * x(4) + x(6)) ^ 2 / ((x(2) + x(4) + x(6)) ^ 2);
dg5dx3 = -(1 - p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(5);
dg5dx4 = -(1 - p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(5) + 0.10e1 * p(1) / (x(2) + x(4) + x(6)) * (0.5e0 * x(4) + x(6)) - p(1) * (0.5e0 * x(4) + x(6)) ^ 2 / ((x(2) + x(4) + x(6)) ^ 2);
dg5dx5 = -(1 - p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(5) + (1 - p(7)) * p(3) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2));
dg5dx6 = -(1 - p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * (1 - p(2)) * x(5) + 0.2e1 * p(1) / (x(2) + x(4) + x(6)) * (0.5e0 * x(4) + x(6)) - p(1) * (0.5e0 * x(4) + x(6)) ^ 2 / ((x(2) + x(4) + x(6)) ^ 2);
dg6dx1 = -(1 - p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(5);
dg6dx2 = -(1 - p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(5);
dg6dx3 = -(1 - p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(5);
dg6dx4 = -(1 - p(7)) * p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(5);
dg6dx5 = (1 - p(7)) * (-p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(5) + p(3) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2));
dg6dx6 = (1 - p(7)) * (-p(3) * p(5) * exp(-(p(5) * (x(1) + x(2) + x(3) + x(4) + x(5) + x(6)))) * p(2) * x(5) + p(4));

dgdx(1,1) = dg1dx1; 
dgdx(1,2) = dg1dx2; 
dgdx(1,3) = dg1dx3; 
dgdx(1,4) = dg1dx4; 
dgdx(1,5) = dg1dx5; 
dgdx(1,6) = dg1dx6; 
dgdx(2,1) = dg2dx1; 
dgdx(2,2) = dg2dx2; 
dgdx(2,3) = dg2dx3; 
dgdx(2,4) = dg2dx4; 
dgdx(2,5) = dg2dx5; 
dgdx(2,6) = dg2dx6; 
dgdx(3,1) = dg3dx1; 
dgdx(3,2) = dg3dx2; 
dgdx(3,3) = dg3dx3; 
dgdx(3,4) = dg3dx4; 
dgdx(3,5) = dg3dx5; 
dgdx(3,6) = dg3dx6; 
dgdx(4,1) = dg4dx1; 
dgdx(4,2) = dg4dx2; 
dgdx(4,3) = dg4dx3; 
dgdx(4,4) = dg4dx4; 
dgdx(4,5) = dg4dx5; 
dgdx(4,6) = dg4dx6; 
dgdx(5,1) = dg5dx1; 
dgdx(5,2) = dg5dx2; 
dgdx(5,3) = dg5dx3; 
dgdx(5,4) = dg5dx4; 
dgdx(5,5) = dg5dx5; 
dgdx(5,6) = dg5dx6; 
dgdx(6,1) = dg6dx1; 
dgdx(6,2) = dg6dx2; 
dgdx(6,3) = dg6dx3; 
dgdx(6,4) = dg6dx4; 
dgdx(6,5) = dg6dx5; 
dgdx(6,6) = dg6dx6; 

end
